<script setup lang="ts">
import { nextTick, onMounted, ref } from 'vue'
import { type Product } from '@/types/Product'
import { useProductStore } from '@/stores/product'
import { useReceiptStore } from '@/stores/receipt'
import { usePosStore } from '@/stores/pos'
import PromotionDialog from '../Promotion/PromotionDialog.vue'
import ProductList from '@/components/ProductList.vue'
import ReceiptCard from './ReceiptCard.vue'
import MemberCard from './MemberCard.vue'
import ReceiptDialogVue from './ReceiptDialog.vue'
import ErrorCashDialog from './ErrorCashDialog.vue'
import ErrorDialog from './ErrorDialog.vue'
import ProductDetailDialog from './ProductDetailDialog.vue'
import ReceiptDialog from './ReceiptDialog.vue'
import ReceiptPaper from './ReceiptPaper.vue'
import ReceiptItemList from '@/components/ReceiptItemList.vue'
import { usePromotionStore } from '@/stores/promotion'

const productStore = useProductStore()
const receiptStore = useReceiptStore()
const PromotionStore = usePromotionStore()
const posStore = usePosStore()

const product = ref<Product>()
const dialogReceipt = ref(false)
const snackbar = ref(false)
const tab = ref(null)
const divreceipItems = ref<HTMLLIElement | null>(null)
function selected(p: Product) {
  if (!p.id) return
  product.value = p
  const pd: Product = {
    id: p.id,
    name: p.name,
    price: p.price,
    type: p.type,
    category: '',
    sweet: 100,
    image: p.image
  }
  if (p.type.name === 'drink') {
    productStore.addProduct(pd)
    posStore.productCard = true
  } else {
    receiptStore.addReceiptItem(pd)
  }

  console.log(`ProductView` + p)

  snackbar.value = true
  nextTick(() => {
    if (divreceipItems.value) divreceipItems.value.scrollTo(0, divreceipItems.value.scrollHeight)
  })
}
// const selected = (p: Product) => {
//   console.log('ProductView' + p)
//   receiptStore.addReceiptItem(p)
//   nextTick(() => {
//     if (divReceiptItems.value) divReceiptItems.value.scrollTo(0, divReceiptItems.value.scrollHeight)
//   })
// }

onMounted(async () => {
  await posStore.getProducts()
  await PromotionStore.getPromotions()
})

const divReceiptItems = ref<HTMLElement | null>(null)
</script>

<template>
  <v-container class="font" style="max-width: 1400px">
    <v-row>
      <v-col cols="12" md="6" class="bgc">
        <v-sheet min-width="300" max-width="700" height="805">
          <v-tabs v-model="tab" color="brown" align-tabs="center">
            <v-tab :value="1">Baverage</v-tab>
            <v-tab :value="2">Cake</v-tab>
            <v-tab :value="3">Food</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <ProductList
                :products="posStore.products1 as any"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="2">
              <ProductList
                :products="posStore.products2 as any"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
            <v-window-item :value="3">
              <ProductList
                :products="posStore.products3 as any"
                @selected-product="selected"
              ></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <v-divider vertical></v-divider>

      <v-col cols="12" md="6" class="bgc">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <div ref="divReceiptItems" height="350" class="overflow-auto">
                <v-sheet min-width="300" max-width="600" height="350">
                  <ReceiptItemList></ReceiptItemList>
                </v-sheet>
              </div>
            </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="600" height="50">
                <MemberCard></MemberCard>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <div ref="divReceiptItems" height="255">
                <v-sheet min-width="300" max-width="600" height="200">
                  <ReceiptCard></ReceiptCard>
                </v-sheet>
              </div>
            </v-col>
            <v-col> </v-col>
            <v-col cols="12">
              <v-sheet min-width="300" max-width="700" height="1">
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        rounded="xl"
                        size="x-large"
                        color="red"
                        @click="receiptStore.initReceipt(), receiptStore.clear()"
                        >Cancel</v-btn
                      >
                    </v-col>
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        rounded="xl"
                        color="green"
                        size="x-large"
                        @click="receiptStore.showReceipt()"
                        >Process</v-btn
                      >
                    </v-col>
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <ErrorDialog></ErrorDialog>
  <ErrorCashDialog></ErrorCashDialog>
  <ReceiptDialogVue></ReceiptDialogVue>
  <ReceiptDialog></ReceiptDialog>
  <ReceiptPaper></ReceiptPaper>
  <PromotionDialog></PromotionDialog>
  <ProductDetailDialog v-if="posStore.productCard === true"></ProductDetailDialog>
</template>

<style scoped>
.font {
  font-family: 'Kanit';
}
</style>
